# coding: utf-8

"""
    STACKIT Observability API

    API endpoints for Observability on STACKIT

    The version of the OpenAPI document: 1.1.1
    Contact: stackit-argus@mail.schwarz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing_extensions import Annotated, Self

from stackit.observability.models.route_serializer import RouteSerializer


class Route(BaseModel):
    """
    Route
    """

    var_continue: Optional[StrictBool] = Field(default=False, alias="continue")
    group_by: Optional[
        Annotated[List[Annotated[str, Field(min_length=1, strict=True, max_length=200)]], Field(max_length=5)]
    ] = Field(default=None, alias="groupBy")
    group_interval: Optional[Annotated[str, Field(min_length=2, strict=True, max_length=8)]] = Field(
        default="5m", alias="groupInterval"
    )
    group_wait: Optional[Annotated[str, Field(min_length=2, strict=True, max_length=8)]] = Field(
        default="30s", alias="groupWait"
    )
    match: Optional[Dict[str, Annotated[str, Field(min_length=1, strict=True, max_length=200)]]] = None
    match_re: Optional[Dict[str, Annotated[str, Field(min_length=1, strict=True, max_length=200)]]] = Field(
        default=None, alias="matchRe"
    )
    receiver: Annotated[str, Field(min_length=1, strict=True, max_length=200)]
    repeat_interval: Optional[Annotated[str, Field(min_length=2, strict=True, max_length=8)]] = Field(
        default="4h", alias="repeatInterval"
    )
    routes: Optional[List[RouteSerializer]] = None
    __properties: ClassVar[List[str]] = [
        "continue",
        "groupBy",
        "groupInterval",
        "groupWait",
        "match",
        "matchRe",
        "receiver",
        "repeatInterval",
        "routes",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Route from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in routes (list)
        _items = []
        if self.routes:
            for _item in self.routes:
                if _item:
                    _items.append(_item.to_dict())
            _dict["routes"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Route from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "continue": obj.get("continue") if obj.get("continue") is not None else False,
                "groupBy": obj.get("groupBy"),
                "groupInterval": obj.get("groupInterval") if obj.get("groupInterval") is not None else "5m",
                "groupWait": obj.get("groupWait") if obj.get("groupWait") is not None else "30s",
                "match": obj.get("match"),
                "matchRe": obj.get("matchRe"),
                "receiver": obj.get("receiver"),
                "repeatInterval": obj.get("repeatInterval") if obj.get("repeatInterval") is not None else "4h",
                "routes": (
                    [RouteSerializer.from_dict(_item) for _item in obj["routes"]]
                    if obj.get("routes") is not None
                    else None
                ),
            }
        )
        return _obj
