# coding: utf-8

"""
    STACKIT Observability API

    API endpoints for Observability on STACKIT

    The version of the OpenAPI document: 1.1.1
    Contact: stackit-argus@mail.schwarz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Annotated, Self

from stackit.observability.models.create_scrape_config_payload_http_sd_configs_inner_oauth2_tls_config import (
    CreateScrapeConfigPayloadHttpSdConfigsInnerOauth2TlsConfig,
)


class CreateScrapeConfigPayloadHttpSdConfigsInnerOauth2(BaseModel):
    """
    OAuth 2.0 authentication using the client credentials grant type. Prometheus fetches an access token from the specified endpoint with the given client access and secret keys. `Additional Validators:` * if oauth2 is in the body no other authentication method should be in the body
    """

    client_id: Annotated[str, Field(min_length=1, strict=True, max_length=200)] = Field(
        description="clientId", alias="clientId"
    )
    client_secret: Annotated[str, Field(min_length=1, strict=True, max_length=200)] = Field(
        description="clientSecret", alias="clientSecret"
    )
    scopes: Optional[List[Annotated[str, Field(min_length=1, strict=True, max_length=200)]]] = Field(
        default=None, description="The URL to fetch the token from."
    )
    tls_config: Optional[CreateScrapeConfigPayloadHttpSdConfigsInnerOauth2TlsConfig] = Field(
        default=None, alias="tlsConfig"
    )
    token_url: Annotated[str, Field(min_length=1, strict=True, max_length=200)] = Field(
        description="The URL to fetch the token from.", alias="tokenUrl"
    )
    __properties: ClassVar[List[str]] = ["clientId", "clientSecret", "scopes", "tlsConfig", "tokenUrl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateScrapeConfigPayloadHttpSdConfigsInnerOauth2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of tls_config
        if self.tls_config:
            _dict["tlsConfig"] = self.tls_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateScrapeConfigPayloadHttpSdConfigsInnerOauth2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "clientId": obj.get("clientId"),
                "clientSecret": obj.get("clientSecret"),
                "scopes": obj.get("scopes"),
                "tlsConfig": (
                    CreateScrapeConfigPayloadHttpSdConfigsInnerOauth2TlsConfig.from_dict(obj["tlsConfig"])
                    if obj.get("tlsConfig") is not None
                    else None
                ),
                "tokenUrl": obj.get("tokenUrl"),
            }
        )
        return _obj
